#!/usr/bin/perl
+# Ikiwiki setup files are perl files that 'use IkiWiki::Setup::foo',
+# passing it some sort of configuration data.
+
+package IkiWiki::Setup;
use warnings;
use strict;
+use IkiWiki;
+use open qw{:utf8 :std};
-package IkiWiki;
-
-sub setup () { # {{{
- my $setup=possibly_foolish_untaint($config{setup});
+sub load ($) { # {{{
+ my $setup=IkiWiki::possibly_foolish_untaint(shift);
delete $config{setup};
- open (IN, $setup) || error("read $setup: $!\n");
+ #translators: The first parameter is a filename, and the second
+ #translators: is a (probably not translated) error message.
+ open (IN, $setup) || error(sprintf(gettext("cannot read %s: %s"), $setup, $!));
my $code;
{
local $/=undef;
close IN;
eval $code;
- error($@) if $@;
+ error("$setup: ".$@) if $@;
+} #}}}
- exit;
+sub merge ($) {
+ my %setup=%{shift()};
+
+ # Merge setup into existing config and untaint.
+ if (exists $setup{add_plugins}) {
+ push @{$setup{add_plugins}}, @{$config{add_plugins}};
+ }
+ if (exists $setup{exclude}) {
+ push @{$config{wiki_file_prune_regexps}}, $setup{exclude};
+ }
+ foreach my $c (keys %setup) {
+ if (defined $setup{$c}) {
+ if (! ref $setup{$c} || ref $setup{$c} eq 'Regexp') {
+ $config{$c}=IkiWiki::possibly_foolish_untaint($setup{$c});
+ }
+ elsif (ref $setup{$c} eq 'ARRAY') {
+ if ($c eq 'wrappers') {
+ # backwards compatability code
+ $config{$c}=$setup{$c};
+ }
+ else {
+ $config{$c}=[map { IkiWiki::possibly_foolish_untaint($_) } @{$setup{$c}}]
+ }
+ }
+ elsif (ref $setup{$c} eq 'HASH') {
+ foreach my $key (keys %{$setup{$c}}) {
+ $config{$c}{$key}=IkiWiki::possibly_foolish_untaint($setup{$c}{$key});
+ }
+ }
+ }
+ else {
+ $config{$c}=undef;
+ }
+ }
+
+ if (length $config{cgi_wrapper}) {
+ push @{$config{wrappers}}, {
+ cgi => 1,
+ wrapper => $config{cgi_wrapper},
+ wrappermode => (defined $config{cgi_wrappermode} ? $config{cgi_wrappermode} : "06755"),
+ };
+ }
} #}}}
+sub dump ($) { #{{{
+ my $file=IkiWiki::possibly_foolish_untaint(shift);
+
+ require IkiWiki::Setup::Standard;
+ my @dump=IkiWiki::Setup::Standard::gendump("Setup file for ikiwiki.");
+
+ open (OUT, ">", $file) || die "$file: $!";
+ print OUT "$_\n" foreach @dump;
+ close OUT;
+}
+
1